<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2005 Electric Sheep Studios                               |
 | Originally by Shitworks, 2004                                           |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
 | h.aloe: a syslog monitoring addon for Ian Berry's Cacti	               |
 +-------------------------------------------------------------------------+
 | Originally released as aloe by: sidewinder at shitworks.com             |
 | Modified by: Harlequin <harlequin@cyberonic.com>                        |
 | 2005-11-10 -- ver 0.1.1 beta                                            |
 |   - renamed to h.aloe                                                   |
 |   - updated to work with Cacti 8.6g                                     |
 |   - included Cacti time selector                                        |
 |   - various other modifications                                         |
 +-------------------------------------------------------------------------+
*/
chdir('../../');

include("./include/auth.php");
include('plugins/haloe/config.php');
include_once('plugins/haloe/functions.php');

if ($haloe_config["graphtime"] && read_graph_config_option("timespan_sel") != "on") {
	$haloe_config["graphtime"] = false;
	$haloe_config["timespan_sel"] = false;
}

	if (isset($_REQUEST["haloe_pdt_change"]) && $_REQUEST["haloe_pdt_change"] == 'true') { /*  predefined_timespan changed  */
		$_SERVER["REQUEST_URI"] = get_query_edited_url($_SERVER["REQUEST_URI"], 'predefined_timespan', $_REQUEST["predefined_timespan"]);
		if ($haloe_config["graphtime"]) {
			unset($_SESSION["sess_current_date1"], $_POST["date1"]);
		} else {
			unset($_SESSION["sess_haloe_array"]["sess_current_date1"], $_POST["date1"]);
		}
		$_GET["predefined_timespan"] = $_REQUEST["predefined_timespan"];
	}elseif (isset($_REQUEST["button_clear_x"]) && $_REQUEST["button_clear_x"]) { /*  pressed reset, so clear out values  */
		$_REQUEST["filter"]="";
		$_REQUEST["efacility"]="0";
		$_REQUEST["elevel"]="0";
		$_REQUEST["output"]="screen";
		unset($_REQUEST["predefined_timespan"]);
		unset($_REQUEST["host"]);
		$_REQUEST["host"][0]="0";
	}else {
	}

include($haloe_config["graphtime"] ? "./include/html/inc_timespan_settings.php" : "plugins/haloe/html/haloe_timespan_settings.php");

input_validate_input_number(get_request_var("predefined_timespan"));

/* set default action */

	/* remember these search fields in session vars so we don't have to keep passing them around */
	if (!isset($_GET["page"])) {
		$_REQUEST["page"]="1";
	}

	if (isset($_REQUEST["filter"])) {
		$_REQUEST["filter"] = sanitize_search_string(get_request_var_request("filter"));
		$_SESSION["sess_haloe_array"]["sess_filter"] = $_REQUEST["filter"];
	}elseif (isset($_SESSION["sess_haloe_array"]["sess_filter"])) {
		$_REQUEST["filter"] = $_SESSION["sess_haloe_array"]["sess_filter"];
		$_REQUEST["filter"] = sanitize_search_string(get_request_var_request("filter"));
	}else{
		$_REQUEST["filter"] = ""; /* default value */
	}

	if (isset($_REQUEST["host"])) {
		$_SESSION["sess_haloe_array"]["sess_host"] = $_REQUEST["host"];
	}elseif (isset($_SESSION["sess_haloe_array"]["sess_host"])) {
		$_REQUEST["host"] = $_SESSION["sess_haloe_array"]["sess_host"];
	}else{
		$_REQUEST["host"][0] = "0"; /* default value */
	}


	if ($haloe_config["graphtime"]) {
		if (isset($_SESSION["sess_current_date1"])) {
			$_REQUEST["date1"] = $_SESSION["sess_current_date1"];
		}
		if (isset($_SESSION["sess_current_date2"])) {
			$_REQUEST["date2"] = $_SESSION["sess_current_date2"];
		}
	} elseif ($haloe_config["timespan_sel"]) {
		if (isset($_SESSION["sess_haloe_array"]["sess_current_date1"])) {
			$_REQUEST["date1"] = $_SESSION["sess_haloe_array"]["sess_current_date1"];
		}
		if (isset($_SESSION["sess_haloe_array"]["sess_current_date2"])) {
			$_REQUEST["date2"] = $_SESSION["sess_haloe_array"]["sess_current_date2"];
		}
	}


	if (isset($_REQUEST["efacility"])) {
		$_SESSION["sess_haloe_array"]["sess_efacility"] = $_REQUEST["efacility"];
	}elseif (isset($_SESSION["sess_haloe_array"]["sess_efacility"])) {
		$_REQUEST["efacility"] = $_SESSION["sess_haloe_array"]["sess_efacility"];
	}else{
		$_REQUEST["efacility"] = ""; /* default value */
	}

	if (isset($_REQUEST["elevel"])) {
		$_SESSION["sess_haloe_array"]["sess_elevel"] = $_REQUEST["elevel"];
	}elseif (isset($_SESSION["sess_haloe_array"]["sess_elevel"])) {
		$_REQUEST["elevel"] = $_SESSION["sess_haloe_array"]["sess_elevel"];
	}else{
		$_REQUEST["elevel"] = ""; /* default value */
	}

	if (!isset($_REQUEST["output"])) {
		$_REQUEST["output"] = "screen"; /* default value */
	}



switch ($_REQUEST["output"]) {

	case 'file' :

		export();
		unset($_REQUEST["output"]); /* clear output so reloads wont re-download */
		break;

	default:
		include_once("./include/top_graph_header.php");

		haloe_messages();

		/* strip timespan to update graph page times */
		if ($haloe_config["graphtime"]) { strip_timespan(); }

		include_once("./include/bottom_footer.php");
		break;
}




function haloe_messages() {

	global $colors, $sql_where, $hostfilter, $config;
	include("./include/config_arrays.php");
	include('plugins/haloe/config.php');

	$url_curr_page = get_browser_query_string();

	if (!empty($hostfilter)) { $where_hostfilter = " WHERE". $hostfilter; }

	if (!($haloe_config["graphtime"]) && !($haloe_config["timespan_sel"])) {
		unset($_REQUEST["date1"], $_REQUEST["date2"]);
	}

	db_connect_real($haloedb_hostname,$haloedb_username,$haloedb_password,$haloedb_default, $haloedb_type);
	$haloe_messages = get_haloe_messages();

	?>
	<tr>
		<td valign="top">
			<form name="haloe_timespan_selector" method="post" action="haloe.php">
			<table width="100%" height="100%" cellspacing="0" cellpadding="0">

				<tr height="40">
					<td colspan="2" bgcolor="#efefef" style="padding: 5px;">
						<?php
						html_start_box("<strong>Syslog Message Filters:</strong>&nbsp;&nbsp;[<font size=1> " . preg_replace("/concat.*BETWEEN /", 'Date/Time BETWEEN ', $sql_where) . " </font>]", "100%", $colors["header"], "3", "center", "");
						?>
						<tr bgcolor="#<?php print $colors["panel"];?>">
							<td class="textHeader">
						<?php
							if ($haloe_config["graphtime"] || $haloe_config["timespan_sel"]) {
								include("plugins/haloe/html/haloe_timespan_selector.php");
							}
							include("plugins/haloe/html/haloe_filter_selector.php");
						?>
							</td>
						</tr>
						<?php
						html_end_box(false);
						?>
					</td>
				</tr>

				<tr>
					<td valign="top" style="padding: 5px; border-right: #aaaaaa 1px solid;" bgcolor='#efefef' width='200'>
						<table align="center" width="200" cellpadding=1 cellspacing=0 border=0>
							<tr>
								<td>
									<?php
									html_start_box("", "100%", $colors["header"], "3", "center", "");
										?>
										<tr>
											<td class="textHeader" nowrap>
												<strong>Select Host(s):&nbsp;</strong>
											</td>
										</tr>
										<tr>
											<td>
												<select name="host[]" multiple size="25" WIDTH="100%" STYLE="width: 100%">
													<option value="0"<?php if ($_REQUEST["host"][0] == "0") {?> selected<?php }?>>show all hosts &nbsp;&nbsp;</option>
													<?php
													$hosts = db_fetch_assoc("SELECT DISTINCT " . $haloe_config["hostField"] . " FROM " . $haloe_config["haloeTable"] . " ORDER BY " . $haloe_config["hostField"] . " ASC");
													if (sizeof($hosts) > 0) {
														foreach ($hosts as $host) {
															print "<option value=" . $host[$haloe_config["hostField"]];
															foreach ($_REQUEST["host"] as $rh) {
																if ($rh == $host[$haloe_config["hostField"]]) {
																	print " selected ";
																	break;
																}
															}
															print ">";
															print $host[$haloe_config["hostField"]] . "</option>\n";
														}
													}
													?>
												</select>
											</td>
										</tr>
									<?php
									html_end_box(false);
									?>
								</td>
							</tr>
						</table>
					</td>

					<td width="100%" valign="top" style="padding: 0px;">
						<table width="100%" cellspacing="0" cellpadding="0">
							<tr>
								<td bgcolor="#ffffff" height="8" style="background-image: url(images/shadow.gif); background-repeat: repeat-x;">
								</td>
							</tr>
							<tr>
								<td width="100%" valign="top" style="padding: 5px;"><?php display_output_messages();?>
									<?php
									$total_rows = db_fetch_cell("SELECT count(*) from " . $haloe_config["haloeTable"] . " " . $sql_where);
									html_start_box("", "98%", $colors["header"], "3", "center", "");
										$hostarray = "";
										foreach ($_REQUEST["host"] as $h) { $hostarray .= "host[]=$h&"; }
										$nav = "<tr bgcolor='#" . $colors["header"] . "'>
											<td colspan='7'>
												<table width='100%' cellspacing='0' cellpadding='0' border='0'>
													<tr>
														<td align='left' class='textHeaderDark'>
															<strong>&lt;&lt; "; if (isset($_REQUEST["page"]) && $_REQUEST["page"] > 1) { $nav .= "<a class='linkOverDark' href='" . get_query_edited_url($url_curr_page, 'page', ($_REQUEST["page"]-1)) . "'>"; } $nav .= "Previous"; if (isset($_REQUEST["page"]) && $_REQUEST["page"] > 1) { $nav .= "</a>"; } $nav .= "</strong>
														</td>\n
														<td align='center' class='textHeaderDark'>
															Showing Rows " . (($haloe_config["rows_per_page"]*($_REQUEST["page"]-1))+1) . " to " . ((($total_rows < $haloe_config["rows_per_page"]) || ($total_rows < ($haloe_config["rows_per_page"]*$_REQUEST["page"]))) ? $total_rows : ($haloe_config["rows_per_page"]*$_REQUEST["page"])) . " of $total_rows [" . haloe_page_select($total_rows) . "]
														</td>\n
														<td align='right' class='textHeaderDark'>
															<strong>"; if (isset($_REQUEST["page"]) && ($_REQUEST["page"] * $haloe_config["rows_per_page"]) < $total_rows) { $nav .= "<a class='linkOverDark' href='" . get_query_edited_url($url_curr_page, 'page', ($_REQUEST["page"]+1)) . "'>"; } $nav .= "Next"; if (($_REQUEST["page"] * $haloe_config["rows_per_page"]) < $total_rows) { $nav .= "</a>"; } $nav .= " &gt;&gt;</strong>
														</td>\n
													</tr>
												</table>
											</td>
										</tr>\n";
										print "	$nav
										<tr bgcolor='#" . $colors["header_panel"] . "'>
											<td class='textSubHeaderDark'>Host</td>
											<td class='textSubHeaderDark'>&nbsp;</td>
											<td class='textSubHeaderDark'>Date</td>
											<td class='textSubHeaderDark'>Time</td>
											<td class='textSubHeaderDark'>&nbsp;</td>
											<td class='textSubHeaderDark'>Message</td>
											<td class='textSubHeaderDark'>Level</td>
										</tr>\n";
										$i = 0;
										if (sizeof($haloe_messages) > 0) {
											foreach ($haloe_messages as $haloe_message) {
												haloe_row_color($colors["alternate"],$colors["light"],$i,$haloe_message[$haloe_config["priorityField"]]); $i++;
												?>
												<td nowrap>
													<?php print $haloe_message[$haloe_config["hostField"]];?>
												</td>
												<td nowrap>
													<?php print " ";?>
												</td>
												<td nowrap>
													<?php print $haloe_message[$haloe_config["dateField"]];?>
												</td>
												<td nowrap>
													<?php print $haloe_message[$haloe_config["timeField"]];?>
												</td>
												<td nowrap>
													<?php print " ";?>
												</td>
												<td>
													<?php print $haloe_message[$haloe_config["textField"]];?>
												</td>
												<td nowrap>
													<?php print $haloe_message[$haloe_config["priorityField"]];?>
												</td>
											</tr>
											<?php
											}
										}else{
											print "<tr><td><em>No Messages</em></td></tr>";
										}
										/* put the nav bar on the bottom as well */
										print $nav;
									html_end_box(false);
									?>

								</td>
							</tr>
						</table>
					</td>
				</tr>
			</table>
			</form>

<?php
}
?>



